xfs
[Top] [All Lists]

[PATCH] xfstests btrfs/020: test device replace on RO btrfs

To: xfs@xxxxxxxxxxx
Subject: [PATCH] xfstests btrfs/020: test device replace on RO btrfs
From: Eryu Guan <eguan@xxxxxxxxxx>
Date: Wed, 23 Oct 2013 19:24:06 +0800
Cc: linux-btrfs@xxxxxxxxxxxxxxx, Eryu Guan <eguan@xxxxxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
btrfs replace on readonly fs should not be allowed.

Regression test case for commit:
bbb651e Btrfs: don't allow the replace procedure on read only filesystems

Signed-off-by: Eryu Guan <eguan@xxxxxxxxxx>
---
 tests/btrfs/020     | 84 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/020.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 87 insertions(+)
 create mode 100755 tests/btrfs/020
 create mode 100644 tests/btrfs/020.out

diff --git a/tests/btrfs/020 b/tests/btrfs/020
new file mode 100755
index 0000000..cd16dc0
--- /dev/null
+++ b/tests/btrfs/020
@@ -0,0 +1,84 @@
+#! /bin/bash
+# FS QA Test No. btrfs/020
+#
+# btrfs device replace test on RO fs
+#
+# Regression test for commit:
+# bbb651e Btrfs: don't allow the replace procedure on read only filesystems
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Red Hat, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+
+status=1       # failure is the default!
+
+_cleanup()
+{
+       cd /
+       rm -f $tmp.*
+       $UMOUNT_PROG $loop_mnt
+       _destroy_loop_device $loop_dev1
+       losetup -d $loop_dev2 >/dev/null 2>&1
+       _destroy_loop_device $loop_dev3
+       rm -rf $loop_mnt
+       rm -f $fs_img1 $fs_img2 $fs_img3
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+
+rm -f $seqres.full
+echo "Silence is golden"
+
+loop_mnt=$TEST_DIR/$seq.$$.mnt
+fs_img1=$TEST_DIR/$seq.$$.img1
+fs_img2=$TEST_DIR/$seq.$$.img2
+fs_img3=$TEST_DIR/$seq.$$.img3
+mkdir $loop_mnt
+$XFS_IO_PROG -f -c "pwrite 0 256m" $fs_img1 >>$seqres.full 2>&1
+$XFS_IO_PROG -f -c "pwrite 0 256m" $fs_img2 >>$seqres.full 2>&1
+$XFS_IO_PROG -f -c "pwrite 0 256m" $fs_img3 >>$seqres.full 2>&1
+
+loop_dev1=`_create_loop_device $fs_img1`
+loop_dev2=`_create_loop_device $fs_img2`
+loop_dev3=`_create_loop_device $fs_img3`
+
+$MKFS_BTRFS_PROG -m raid1 -d raid1 $loop_dev1 $loop_dev2 >>$seqres.full 2>&1
+$MOUNT_PROG -o ro $loop_dev1 $loop_mnt
+
+# Fail the second device and replace with the third
+_destroy_loop_device $loop_dev2
+$BTRFS_UTIL_PROG replace start -B 2 $loop_dev3 $loop_mnt >>$seqres.full 2>&1 
&& \
+_fail "FAIL: Device replaced on RO btrfs"
+
+status=0
+exit
diff --git a/tests/btrfs/020.out b/tests/btrfs/020.out
new file mode 100644
index 0000000..20d7944
--- /dev/null
+++ b/tests/btrfs/020.out
@@ -0,0 +1,2 @@
+QA output created by 020
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 2f74139..1159499 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -22,3 +22,4 @@
 017 auto quick
 018 auto quick
 019 auto quick
+020 auto quick
-- 
1.8.3.1

<Prev in Thread] Current Thread [Next in Thread>